<?php

function _readArray($file) {
  if(file_exists($file)) {
    $data = file($file);

    for($i = sizeof($data); $i-->0; ) {
      $fex = explode("|", $data[$i]);

      $retdata[trim($fex[0])]=trim($fex[1]);
    }
  }

  return $retdata;
}

function _writeArray($file, $array, $mode) {
  $fp = @fopen($file, $mode) or die("Error while _writeArray to $file");
  if(flock($fp, LOCK_EX + LOCK_NB)) {
    while(list($key,$val) = each($array)) {
      fputs($fp, $key."|".$val."\n");
    }
    # Take notice of successful execution.
    $logged = 1;
  }
  else echo("flock failure on $file");
  
  if (flock($fp, LOCK_UN))
    fclose($fp);

  else echo("flock failure on $file");
  return $logged;
}

function counter_log_ip($ip,$logfile_prefix) {
  $iplog = $logfile_prefix . "iplog.dat";

  _writeArray($iplog, array($ip => gethostbyaddr($ip)), "a+");
}

function counter_check_ip($ip,$logfile_prefix) {
  $ipfile = $logfile_prefix . "count_ip.dat";

  $ips = array();

  if(sizeof($old_ips = _readArray($ipfile))) {
    while(list($key,$val) = each($old_ips)) {
      if($val+86400 > time())  // ein Tag her?
        $ips[$key] = $val;
    }
  }

  if(!$ips[$ip]) { // nicht drin -> zaehlen
    $check = 1;

    $ips[$ip] = time();
  }

  _writeArray($ipfile, $ips, "w+");

  return $check;
}

function counter($logfile_prefix,$ip,$donotcount) { 
  $countfile = $logfile_prefix . "count.dat";
  
  if(file_exists($countfile) && $countfile_fp = fopen($countfile,"r")) {
    $count = fgets($countfile_fp,15);
    fclose($countfile_fp);
  } else
    $count = 0;

  if(!$donotcount) {
    if(counter_check_ip($ip,$logfile_prefix)) {
      $count = $count + 1;

      $countfile_fp = fopen($countfile,"w+");
      fputs($countfile_fp,$count);
      fclose($countfile_fp);

      counter_log_ip($ip,$logfile_prefix);
    }
  }

  return $count;
}

?>